; 
;
; XML PARSER CLASS
;
; 

	.586
	.model flat, stdcall
	option casemap :none

	include \masm32\include\kernel32.inc
	include \masm32\include\windows.inc
	include \masm32\include\user32.inc

	include \masm32\include\masm32.inc

	include XMLparser.inc
	
	DEBUG		EQU 0
	
IF DEBUG EQ 1
	include \masm32\include\debug.inc
ENDIF

; 

.data
	XMLParserTemplate	XMLParser <>
	
	XMLtransitions		dd XMLParser.Start1
				dd XMLParser.Start2
				
				dd XMLParser.Start1OpenTag1
				dd XMLParser.Start1OpenTag2
				dd XMLParser.Start1OpenTag3
				dd XMLParser.Start1OpenTag4
				
				dd XMLParser.CommandName1
				dd XMLParser.CommandName2
				dd XMLParser.CommandName3

				dd XMLParser.Command1
				dd XMLParser.Command2
				
				dd XMLParser.CommandEnd1
				dd XMLParser.CommandEnd2
				
				dd XMLParser.Start2OpenTag1
				dd XMLParser.Start2OpenTag2
				
				dd XMLParser.OpenTag1
				dd XMLParser.OpenTag2
				dd XMLParser.OpenTag3
				dd XMLParser.OpenTag4
				
				dd XMLParser.AttribStart1
				dd XMLParser.AttribStart2
				dd XMLParser.AttribStart3
				dd XMLParser.AttribStart4

				dd XMLParser.AttribName1
				dd XMLParser.AttribName2
				dd XMLParser.AttribName3
				
				dd XMLParser.AfterAttribName1
				dd XMLParser.AfterAttribName2
				
				dd XMLParser.Attrib1Value1
				dd XMLParser.Attrib1Value2
				
				dd XMLParser.AttribValue1
				dd XMLParser.AttribValue2
				
				dd XMLParser.AfterAttribValue1
				dd XMLParser.AfterAttribValue2
				dd XMLParser.AfterAttribValue3
				dd XMLParser.AfterAttribValue4

				dd XMLParser.EmptyTag1
				dd XMLParser.EmptyTag2
				
				dd XMLParser.AfterOpenTag1
				dd XMLParser.AfterOpenTag2
				dd XMLParser.AfterOpenTag3

				dd XMLParser.After2OpenTag1
				dd XMLParser.After2OpenTag2
				dd XMLParser.After2OpenTag3

				dd XMLParser.StartTag1
				dd XMLParser.StartTag2
				dd XMLParser.StartTag3
				dd XMLParser.StartTag4
				dd XMLParser.StartTag5
				dd XMLParser.StartTag6

				dd XMLParser.CData1
				dd XMLParser.CData2
				dd XMLParser.CData3

				dd XMLParser.AfterCData1
				
				dd XMLParser.Start1CloseTag1
				dd XMLParser.Start1CloseTag2
				
				dd XMLParser.Start2CloseTag1
				dd XMLParser.Start2CloseTag2
				
				dd XMLParser.CloseTag1
				dd XMLParser.CloseTag2
				dd XMLParser.CloseTag3
				dd XMLParser.CloseTag4

				dd XMLParser.Close2Tag1
				dd XMLParser.Close2Tag2

				dd XMLParser.AfterCloseTag1
				dd XMLParser.AfterCloseTag2
				
				dd XMLParser.CommentStart1
				dd XMLParser.Comment2Start1

				dd XMLParser.Comment1
				dd XMLParser.Comment2
				dd XMLParser.Comment3

				dd XMLParser.CommentEnd1
				dd XMLParser.CommentEnd2
				dd XMLParser.CommentEnd3

				dd XMLParser.Comment2End1
				dd XMLParser.Comment2End2
				dd XMLParser.Comment2End3

				dd NULL

	XML_M_PARSE_ERROR		db 'Error parsing',0                 
	XML_M_TAGS_DONT_MATCH		db 'EndTag does not match StartTag',0
	XML_M_INTERNAL_ERROR		db 'Internal parser error.',0        
	XML_M_ENCODING_NOT_SUPPORTED	db 'Encoding not supported.',0       
	XML_M_GENERAL_ERROR		db 'General error.',0

	XML_TEXT_ROW			db '000,',0
	XML_TEXT_COL			db '000.',0
	XML_MSG_FORMAT			db '%s at (%u,%u).',0
	XML_COMMAND_NAME		db 'x',0,'m',0,'l',0,0,0	; unicode string

IF DEBUG EQ 1
; DEBUG 

	DebugStateStr		STRUCT
				state	dd ?
				text	db 16 dup (0)
	DebugStateStr		ENDS

	DebugStateNames		LABEL DWORD
	 DebugState1		DebugStateStr <ST_START,		'Start'>
	 DebugState2		DebugStateStr <ST_START1OPENTAG,	'Start1OpenTag'>
	 DebugState3		DebugStateStr <ST_START2OPENTAG,	'Start2OpenTag'>
	 DebugState4		DebugStateStr <ST_OPENTAG,		'OpenTag'>
	 DebugState5		DebugStateStr <ST_COMMANDNAME,		'CommandName'>
	 DebugState6		DebugStateStr <ST_COMMAND,		'Command'>
	 DebugState7		DebugStateStr <ST_COMMANDEND,		'CommandEnd'>
	 DebugState8		DebugStateStr <ST_ATTRIBSTART,		'AttribStart'>
	 DebugState9		DebugStateStr <ST_ATTRIBNAME,		'AttribName'>
	 DebugState10		DebugStateStr <ST_AFTERATTRIBNAME,	'AfterAttribName'>
	 DebugState11		DebugStateStr <ST_ATTRIB1VALUE,		'Attrib1Value'>
	 DebugState12		DebugStateStr <ST_ATTRIBVALUE,		'AttribValue'>
	 DebugState13		DebugStateStr <ST_AFTERATTRIBVALUE,	'AfterAttribVal'>
	 DebugState14		DebugStateStr <ST_EMPTYTAG,		'EmptyTag'>
	 DebugState15		DebugStateStr <ST_AFTEROPENTAG,		'AfterOpenTag'>
	 DebugState16		DebugStateStr <ST_AFTER2OPENTAG,	'After2OpenTag'>
	 DebugState17		DebugStateStr <ST_STARTTAG,		'StartTag'>
	 DebugState18		DebugStateStr <ST_CDATA,		'CData'>
	 DebugState19		DebugStateStr <ST_AFTERCDATA,		'AfterCData'>
	 DebugState20		DebugStateStr <ST_START1CLOSETAG,	'Start1CloseTag'>
	 DebugState21		DebugStateStr <ST_START2CLOSETAG,	'Start2CloseTag'>
	 DebugState22		DebugStateStr <ST_CLOSETAG,		'CloseTag'>
	 DebugState23		DebugStateStr <ST_CLOSE2TAG,		'Close2Tag'>
	 DebugState24		DebugStateStr <ST_AFTERCLOSETAG,	'AfterCloseTag'>
	 DebugState25		DebugStateStr <ST_COMMENTSTART,		'CommentStart'>
	 DebugState26		DebugStateStr <ST_COMMENT2START,	'Comment2Start'>
	 DebugState27		DebugStateStr <ST_COMMENT,		'Comment'>
	 DebugState28		DebugStateStr <ST_COMMENTEND,		'CommentEnd'>
	 DebugState29		DebugStateStr <ST_COMMENT2END,		'Comment2End'>
	 			dd NULL

; DEBUG 
ENDIF

; 

.code

IF DEBUG EQ 1
DebugState		PROC USES ebx edi

			mov	edi,offset DebugStateNames
			mov	eax,[esi+XMLParser.charParserEFSM.lpTransitionTable]
			sub	eax,esi
@1:
			mov	ebx,(DebugStateStr PTR [edi]).state
			or	ebx,ebx
			jz @3
			cmp	eax,ebx
			jz @2
			add	edi,sizeof DebugStateStr
			jmp @1
@2:
			add	edi,DebugStateStr.text

			PrintStringByAddr edi
@3:
			ret

DebugState		ENDP

ENDIF

; 

	include XMLfunctions.inc

; 
;
; Creates an instance of the XMLParser class
;
; 

XML_createParser	PROC USES ecx edi esi StartTagHandler:DWORD,CDATAHandler:DWORD,EndTagHandler:DWORD,CommandHandler:DWORD

			mov	eax,sizeof XMLParser
			invoke GlobalAlloc,GPTR,eax			; allocate space for parser instance
			or	eax,eax
			jz @3
			mov	esi,eax

		; initialize instance from template
			mov	edi,offset XMLParserTemplate
			mov	ecx,(sizeof XMLParser-1)/4
@1:
			mov	eax,[edi+ecx*4]
			mov	[esi+ecx*4],eax
			sub	ecx,1
			jnc	@1

			ASSUME esi:PTR XMLParser
		; initialize handlers
			mov	eax,StartTagHandler
			mov	ecx,CDATAHandler
			mov	[esi].lpStartTagHandler,eax
			mov	[esi].lpCDATAHandler,ecx
			mov	eax,EndTagHandler
			mov	ecx,CommandHandler
			mov	[esi].lpEndTagHandler,eax
			mov	[esi].lpCommandHandler,ecx

		; allocate auxillary string
			invoke GlobalAlloc,GPTR,XML_AUX_STRING_SIZE+2
			or	eax,eax
			jnz @11
				invoke GlobalFree,esi
				xor	eax,eax
				jmp @3
@11:
			mov	[esi].lpAuxString,eax
			mov	[esi].lpChar,eax
			add	eax,XML_AUX_STRING_SIZE
			mov	[esi].lpAuxStringEnd,eax

			push	esi
		; create character level parser - EFSM
			lea	eax,[esi+ST_START]		; start state's transition table address
			push	DWORD PTR NULL			; no accept states
			push	eax				; starting transition table
			lea	eax,[esi+XMLParser.charParserEFSM]
			push	eax				; lpEFSM
			call EFSM_Init
			pop	esi
@2:
		; add parser instance address to transition addresses
			mov	edi,offset XMLtransitions	; transition address table
			mov	ecx,esi				; address of parser instance
@21:
			mov	eax,[edi]			;get offset
			or	eax,eax				;end of list
			jz @22
			add	(EFSMTransitionN PTR [esi+eax]).dwStateOut,ecx
			add	edi,4
			jmp @21
@22:
			mov	eax,esi
@3:
			ret

			ASSUME esi:NOTHING
XML_createParser	ENDP

; 
;
; Destroyes the given instance of the XMLParser class
;
; 

XML_destroyParser	PROC USES ebx esi lpParser:DWORD

			mov	esi,lpParser
			ASSUME esi:PTR XMLParser
			
			mov	ebx,[esi].dwCurrentLevel		; number of stored tags
			or	ebx,ebx
			jz @2
@1:
		; free allocated strings
			mov	eax,[esi+ebx*4].lpTags
			or	eax,eax
			jz @11
			invoke GlobalFree,eax
@11:
			sub	ebx,1
			jnz @1
@2:
		; free auxillary string
			mov	eax,[esi].lpAuxString
			invoke GlobalFree,eax
@3:
		; free XMLParser structure			
			invoke GlobalFree,esi
@4:
			ret
			
			ASSUME esi:NOTHING
XML_destroyParser	ENDP
; 
;
; Reinitializes the XMLParser
;
; 

XML_resetParser		PROC USES ebx esi lpParser:DWORD

			mov	esi,lpParser
			ASSUME esi:PTR XMLParser

			xor	eax,eax
		; initialize attributes
			mov	[esi].encoding,ENCODING_UNKNOWN		; set encoding undetermined
			mov	ebx,[esi].lpAuxString
			mov	[esi].dwCurrentLevel,eax
			mov	[esi].dwCurrentAttrib,eax
			mov	[esi].dwErrorCode,eax
			mov	[esi].lpCommandHandler,eax
			mov	[esi].lpCommand,eax
			mov	[esi].lpChar,ebx			; reset aux.string pointer

		; set tag pointers to NULL
			mov	edi,XML_MAX_DEPTH_OF_TAGS-1
@11:
			mov	eax,[esi+edi*4].lpTags
			or	eax,eax
			jz @12
			invoke GlobalFree,eax
			; or	eax,eax
			; jz @12
			;	mov	[esi].dwErrorCode,XML_INTERNAL_ERROR
			;	stc
			;	jmp @3
@12:
			xor	eax,eax
			mov	[esi+edi*4].lpTags,eax
			sub	edi,1
			jnc @11

@2:
		; set attrib allocated attrib strings
			mov	edi,XML_MAX_NUM_OF_ATTRIBS
@21:
			mov	eax,[esi+edi*8].lpAttribs
			invoke GlobalFree,eax
			mov	eax,[esi+edi*8+4].lpAttribs
			invoke GlobalFree,eax
@22:
			xor	eax,eax
			mov	[esi+edi*8].lpAttribs,eax
			mov	[esi+edi*8+4].lpAttribs,eax
			sub	edi,1
			jnc @21

			mov	[esi].dwCurrentRow,1
			mov	[esi].dwCurrentCol,1

		; reset EFSM automaton
			lea	eax,[esi+ST_START]			; start state's transition table address
			push	eax
			push	esi
			add	DWORD PTR [esp],XMLParser.charParserEFSM
			call EFSM_Reset
			clc
@3:
			ret

			ASSUME esi:NOTHING
XML_resetParser		ENDP

; 
;
; Parses XML string and calls event handlers
;
;  IN:	esi - lpXMLParser
;
; OUT:	eax - NULL or ErrorMessage
;	esi - lpXMLParser
;
; 
XML_parse		PROC USES edi esi lpParser:DWORD,lpXMLstring:DWORD,dwBytes:DWORD
			mov	esi,lpParser
; PrintHex esi,'lpParser'
			ASSUME esi:PTR XMLParser
; LOCAL dwBufferEnd:DWORD
			mov	edi,lpXMLstring
			mov	[esi].lpXMLstream,edi
			mov	eax,dwBytes
			add	eax,edi
			mov	dwBytes,eax
@1:
; 
	IF DEBUG EQ 1
		invoke DebugState
	ENDIF
; 
			invoke XML_ReadChar
			jnc @11						; exit on error
@Error:
				xor	eax,eax				; return FALSE
				jmp @2
@11:
; 
	IF DEBUG EQ 1
		PrintHex eax,'Input'
	ENDIF
; 
			mov	[esi].dwErrorCode,XML_PARSE_ERROR

			push	eax
			push	esi
			add	DWORD PTR [esp],XMLParser.charParserEFSM
			call EFSM_NextState
			jc @Error
@12:
			add	[esi].dwCurrentCol,1

			cmp	edi,dwBytes
			jnz @1
			mov	eax,1					; return TRUE
@2:
			ret

			ASSUME esi:NOTHING
XML_parse		ENDP

; 
;
; Returns an error message string selected by errorCode
;
;  IN:
;
; OUT:	eax - NULL or lpErrorMessage
;
; 

XML_error		PROC  lpParser:DWORD
			mov	esi,lpParser
			ASSUME esi:PTR XMLParser

			mov	eax,[esi].dwErrorCode
			or	eax,eax
			jz @3
			cmp	eax,XML_PARSE_ERROR
			jnz @11
				mov	eax,offset XML_M_PARSE_ERROR
				jmp @2
@11:
			cmp	eax,XML_TAGS_DONT_MATCH
			jnz @12
				mov	eax,offset XML_M_TAGS_DONT_MATCH
				jmp @2
@12:
			cmp	eax,XML_INTERNAL_ERROR
			jnz @13
				mov	eax,offset XML_M_INTERNAL_ERROR
				jmp @3
@13:
			cmp	eax,XML_ENCODING_NOT_SUPPORTED
			jnz @14
				mov	eax,offset XML_M_ENCODING_NOT_SUPPORTED
				jmp @3
@14:
			mov	eax,offset XML_M_GENERAL_ERROR
@2:
			invoke wsprintf,[esi].lpAuxString,offset XML_MSG_FORMAT,eax,[esi].dwCurrentRow,[esi].dwCurrentCol
			mov	eax,[esi].lpAuxString
@3:
			ret
			ASSUME esi:NOTHING
XML_error		ENDP

end
